; Cwiczenie nr 2 na laboratoria z Asemblerow
; (C) 2000, 2001 Marcin Owsiany
; Program dodajacy i mnozacy macierze
JUMPS
.model Small,Stdcall

.stack 100h

.data
	helptxt db "Uzycie programu: mm plik.wej plik.wyj", 13, 10
		db "Gdzie:", 13, 10
		db "      plik.wej - plik z danymi wejsciowymi", 13, 10
		db "      plik.wyj - plik wyjsciowy$"
	erropen	db "Nie udalo sie otworzyc pliku.$"
	errcreat db "Nie udalo sie utworzyc pliku.$"
	errclose db "Nie udalo sie zamknac pliku.$"
	erread	db "Nie udalo sie czytac z pliku.$"
	errdata	db "Niepoprawne dane wejsciowe.$"
	errlseek db "Nie udalo sie przesunac pozycji w pliku.$"
	errmatlf  db "Niepoprawny zapis macierzy.$"
	errcolnumdif db "Nie mozna dodac macierzy z powodu roznych ilosci kolumn.$"
	errrownumdif db "Nie mozna dodac macierzy z powodu roznych ilosci wierszy.$"
	errmulnumdif db "Nie mozna pomnozyc macierzy z powodu nieodpowiednich wymiarow.$"
	errwrt	db "Nie udalo sie pisac do pliku.$"
	errtoobig db "Liczba wieksza niz 100.$"

	ofmsg	db "Otwieranie pliku.$"
	crmsg	db "Tworzenie pliku.$"
	clmsg	db "Zamykanie pliku.$"
	mcmsg	db "Pobieranie ilosci kolumn macierzy.$"
	mvmsg	db "Pobieranie ilosci wierszy macierzy.$"

	ld1msg	db "Pobieranie pierwszej macierzy.$"
	ld2msg	db "Pobieranie drugiej macierzy.$"
	mamsg	db "Dodawanie macierzy.$"
	mmmsg	db "Mnozenie macierzy.$"
	m1dmsg	db "Zapisywanie sumy macierzy.$"
	m2dmsg	db "Zapisywanie iloczynu macierzy.$"
	swdmsg	db "Zapisywanie wymiarow sumy.$"
	mwdmsg	db "Zapisywanie wymiarow iloczynu.$"

	endl	db '', 13, 10, '$'		; CL+LF
	srcfnam	db 13 dup (0)	; dzieki temu nazwa pliku
	dstfnam	db 13 dup (0)	; jest zakonczona zerem
	srcfh	dw ?
	dstfh	dw ?
	m1	db 10000 dup (?)
	m2	db 10000 dup (?)
	m	dw 10000 dup (?)
	tmpnbuf	db 7  dup (0)
	tmpnbuf2 db 10 dup (0)
	m1c	db ?
	m1r	db ?
	m2c	db ?
	m2r	db ?
	tmpnum	db ?
	tmpwrd	dw ?
	tmpwrd2 dw ?
	sfpos	dw 0
	spc	db ' '
	zerko   db '0'

.code
start:
		mov ax, @data
		mov ds, ax
; parametry programu
		xor  cx, cx
		mov  cl, es:[80h]
		cmp  cx, 0				; jesli brak opcji...
		jne  exopt
		mov  dx, offset helptxt
		call helpmsg				; ...to zglos blad
exopt:		call strcpy, offset srcfnam, 82h	; pobierz nazwe pliku zrodlowego
		add  ax, 82h
		call strcpy, offset dstfnam, ax		; pobierz nazwe pliku docelowego
							mov  dx, offset ofmsg
							call debugmsg
; otworz plik wejsciowy
		call open,   offset srcfnam		; otworz plik wej.
							mov  dx, offset mcmsg
							call debugmsg
; macierz 1
		call readnum, 0020h			; odczyt il. kolumn
		mov  al, tmpnum
		mov  m1c, al
							mov  dx, offset mvmsg
							call debugmsg
		call readnum, 0013			; odczyt il. wierszy
		mov  al, tmpnum
		mov  m1r, al

		call getlf
							mov  dx, offset ld1msg
							call debugmsg
		call ldmatrix1
							mov  dx, offset mcmsg
							call debugmsg
; macierz 2
		call readnum, 0020h			; odczyt il. kolumn
		mov  al,  tmpnum
		mov  m2c, al
							mov  dx, offset mvmsg
							call debugmsg
		call readnum, 0013			; odczyt il. wierszy
		mov  al,  tmpnum
		mov  m2r, al

		call getlf
							mov  dx, offset ld2msg
							call debugmsg
		call ldmatrix2
							mov  dx, offset clmsg
							call debugmsg
; zamknij plik wejsciowy
		call close,  srcfh
							mov  dx, offset crmsg
							call debugmsg
; utworz plik wyjsciowy
		call creat,  offset dstfnam
		
; sprawdz rozmiary
		mov  al,  m1c				; czy mozna je dodac?
		mov  bl,  m2c
		cmp  al,  bl
		je   mtrxcolsmatch
		mov  dx,  offset errcolnumdif			; rozna ilosc kolumn
		call debugmsg
		jmp  trymul
mtrxcolsmatch:	mov  al,  m1r
		mov  bl,  m2r
		cmp  al,  bl
		je   mtrxrowsmatch
		mov  dx,  offset errrownumdif			; rozna ilosc wierszy
		call debugmsg
		jmp  trymul

mtrxrowsmatch:						; mozna dodac
							mov  dx, offset mamsg
							call debugmsg
; dodaj
		call addmatrices
							mov  dx, offset swdmsg
							call debugmsg
		call dumpaddsizes
							mov  dx, offset m1dmsg
							call debugmsg
		call dumpaddmatrix
trymul:
; sprawdz rozmiary
		mov  al,  m1c				; czy mozna je pomnozyc?
		mov  bl,  m2r
		cmp  al,  bl
		je   mtrxmulmatch
		mov  dx,  offset errmulnumdif		; rozna ilosc kolumn
		call debugmsg
		jmp  donotmul
mtrxmulmatch:						; mozna mnozyc
							mov  dx, offset mmmsg
							call debugmsg
		call mulmatrices
							mov  dx, offset mwdmsg
							call debugmsg
		call dumpmulsizes
							mov  dx, offset m2dmsg
							call debugmsg
		call dumpmulmatrix
donotmul:						mov  dx, offset clmsg
							call debugmsg
; zamknij plik wyjsciowy
		call close,  dstfh
; i zakoncz program
		mov  ax, 4c00h
		int  21h

; zapisuje do pliku CR+LF
dumpendl proc
		push ax
		push bx
		push cx
		push dx
		xor  ax, ax
		mov  ah, 40h				; write()
		mov  bx, dstfh
		mov  cx, 2
		mov  dx, offset endl
		int  21h
		jc   deerr
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret
deerr:		mov  dx, offset errwrt
		call helpmsg
dumpendl endp

; zapisuje do pliku jedna spacje
dumpspc proc
		push ax
		push bx
		push cx
		push dx
		xor  ax, ax
		mov  ah, 40h				; write()
		mov  bx, dstfh
		mov  cx, 1
		mov  dx, offset spc
		int  21h
		jc   dserr
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret
dserr:		mov  dx, offset errwrt
		call helpmsg
dumpspc endp

; zapisuje do pliku dane slowo
dumpword proc what:WORD
		push ax
		push bx
		push cx
		push dx
		push di
		mov  cx, 6			; ile cyfr
		mov  di, cx
		mov  cx, 10
		mov  ax, what			; pobierz liczbe
		mov  bx, offset tmpnbuf		; bufor
dwnxt:		xor  dx, dx			; zeruj wynik
		div  cx				; podziel
		add  dl, '0'			; zamien na znak
		mov  byte ptr [bx+di], dl	; zapisz do tablicy
		dec  di
		cmp  al, 0			; po zamianie wszystkich cyfr
		jnz  dwnxt
		inc  di				; zwroc offset 1szego znaku

		xor  ax, ax
		mov  ah, 40h			; write()
		mov  bx, dstfh
		mov  cx, 7
		sub  cx, di
		mov  dx, offset tmpnbuf
		add  dx, di
		int  21h
		jc   dwerr
		pop  di
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret
dwerr:		mov  dx, offset errwrt
		call helpmsg
dumpword endp

; zapisuje do pliku dane slowo
dumpword2 proc what:WORD, what2:WORD
		push ax
		push bx
		push cx
		push dx
		push di
		mov  dx, what2			; starszy bajt
		mov  ax, what			; mlodszy bajt
		mov  cx, 1000
		div  cx
		push ax
		push dx
		mov  cx, 6			; ile cyfr
		mov  di, cx
		mov  cx, 10
		pop  ax				; pobierz liczbe
		mov  bx, offset tmpnbuf2	; bufor
dwnxt2:		xor  dx, dx			; zeruj wynik
		div  cx				; podziel
		add  dl, '0'			; zamien na znak
		mov  byte ptr [bx+di], dl	; zapisz do tablicy
		dec  di
		cmp  al, 0			; po zamianie wszystkich cyfr
		jnz  dwnxt2

		pop  ax				; nastepne slowo
		cmp  ax, 0			; jesli nie zero
		je   dw2fin			; to
		xor  dx, dx
		mov  dl, '0'
dw2nzero:	cmp  di, 3			; probujemy dopisac
		jle  dwnxt22			; brakujace zera
		mov  byte ptr [bx+di], dl
		dec  di
		jmp  dw2nzero

dwnxt22:	xor  dx, dx			; zeruj wynik
		div  cx				; podziel
		add  dl, '0'			; zamien na znak
		mov  byte ptr [bx+di], dl	; zapisz do tablicy
		dec  di
		cmp  al, 0			; po zamianie wszystkich cyfr
		jnz  dwnxt22

dw2fin:		inc  di				; zwroc offset 1szego znaku

		xor  ax, ax
		mov  ah, 40h			; write()
		mov  bx, dstfh
		mov  cx, 7
		sub  cx, di
		mov  dx, offset tmpnbuf2
		add  dx, di
		int  21h
		jc   dwerr2
dw2end:		pop  di
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret
dwerr2:		mov  dx, offset errwrt
		call helpmsg
dumpword2 endp

; zapisuje do pliku wielkosci macierzy powstalej z dodawania
dumpaddsizes proc
		push ax
		xor  ax, ax
		mov  al, m1c
		call dumpword, ax
		call dumpspc
		xor  ax, ax
		mov  al, m1r
		call dumpword, ax
		call dumpendl
		pop  ax
		ret
dumpaddsizes endp

; zapisuje do pliku wielkosci macierzy powstalej z mnozenia
dumpmulsizes proc
		push ax
		xor  ax, ax
		mov  al, m2c
		call dumpword, ax
		call dumpspc
		xor  ax, ax
		mov  al, m1r
		call dumpword, ax
		call dumpendl
		pop  ax
		ret
dumpmulsizes endp

; zapisuje do pliku wiersz macierzy
dumprow proc drsize:WORD, off:WORD
		push cx
		push bx
		push di
		mov  cx, drsize
		mov  bx, off
		xor  di, di
drr:		dec  cx
		cmp  cx, 0
		je   dprendl
		call dumpword, word ptr [bx+di]
		call dumpspc
		inc  di
		inc  di				; WORD
		jmp  drr
dprendl:	call dumpword, word ptr [bx+di]
		call dumpendl
		pop  di
		pop  bx
		pop  cx
		ret
dumprow endp

; zapisuje do pliku wiersz macierzy
dumprow2 proc drsize:WORD, off:WORD
		push cx
		push bx
		push di
		mov  cx, drsize
		mov  bx, off
		xor  di, di
drr2:		dec  cx
		cmp  cx, 0
		je   dprendl2
		call dumpword2, word ptr [bx+di], word ptr [bx+di+2]
		call dumpspc
		inc  di
		inc  di				; WORD
		inc  di
		inc  di				; x 2
		jmp  drr2
dprendl2:	call dumpword2, word ptr [bx+di], word ptr [bx+di+2]
		call dumpendl
		pop  di
		pop  bx
		pop  cx
		ret
dumprow2 endp

; zapisuje do pliku cala macierz powstala z dodawania
dumpaddmatrix proc
		push cx
		push bx
		push ax
		xor  ax, ax
		mov  al, m1c			; dlugosc rzedu
		xor  cx, cx
		mov  cl, m1r			; ilosc rzedow
		mov  bx, offset m
dmar:		call dumprow, ax, bx
		add  bx, ax
		add  bx, ax			; WORD
		loop dmar
		pop  ax
		pop  bx
		pop  cx
		ret
dumpaddmatrix endp

; zapisuje do pliku cala macierz powstala z mnozenia
dumpmulmatrix proc
		push dx
		push cx
		push bx
		xor  cx, cx
		mov  cl, m1r			; ilosc rzedow
		xor  dx, dx
		mov  dl, m2c			; dlugosc rzedu
		mov  bx, offset m
dmmr:		call dumprow2, dx, bx
		add  bx, dx
		add  bx, dx			; WORD
		add  bx, dx
		add  bx, dx			; x 2
		loop dmmr
		pop  bx
		pop  cx
		pop  dx
		ret
dumpmulmatrix endp

; dodaje macierze
addmatrices proc
		push ax
		push bx
		push cx
		push si
		push di
		xor  si, si				; zeruj offset
		xor  cx, cx
		xor  ax, ax
		mov  al, m1c
		mov  cl, m1r
		mul  cl
		mov  cx, ax
admnext:	xor  ax, ax				; zeruj sume
		mov  bx, offset m1			; wez z M1
		mov  al, byte ptr [bx+si]		; liczbe o danym offsecie
		mov  bx, offset m2			; dodaj do niej
		add  al, byte ptr [bx+si]		; liczbe z M2
		mov  bx, offset m			; do M
		xor  di, di				;  zeruj offset wyniku
		add  di, si				;  offset wyniku =
		add  di, si				;  offset zrodla * 2 (WORD)
		mov  word ptr [bx+di], ax		; przenies sume
		inc  si					; zwieksz offset
		loop admnext				; az dodasz wszystko
		pop  di
		pop  si
		pop  cx
		pop  bx
		pop  ax
		ret
addmatrices endp

; mnozy macierze
mulmatrices proc
		push ax
		push bx
		push dx
		push si
		push di
		xor  ax, ax
		mov  al, m1c	; dlugosc serii liczb
		xor  bx, bx
		mov  bl, m1r	; ilosc rzedow
		xor  dx, dx
		mov  dl, m2c	; ilosc kolumn
		xor  si, si	; rzedy
mmnextrow:	xor  di, di	; kolumny

		mmnextcell:	call mulcell, si, di, ax
				inc  di
				cmp  di, dx
				jle  mmnextcell
		inc  si
		cmp  si, bx
		jle  mmnextrow
		pop  di
		pop  si
		pop  dx
		pop  bx
		pop  ax
		ret		
mulmatrices endp

; mnozy i dodaje odpowiedni rzad i kolumne
;
; przy danych macierzach
;
;	,-		       -.     ,-                     -.
;	|  a00 a01 a02 ... a0n  |     |  b00 b01 b02 ... b0n  |
;	|  a10 a11 a12 ... a1n  |     |  b10 b11 b12 ... b1n  |
;	|  a20 a21 a22 ... a2n  |     |  b20 b21 b22 ... b2n  |
;	|   .		        |  .  |   .                   |
;	|   .		        |     |   .                   |
;	|   .		        |     |   .                   |
;	|  an0 an1 an2 ... ann  |     |  bn0 bn1 bn2 ... bnn  |
;	|_		       _|     |_                     _|
;
; i parametrach row, col i size
;
; wstawia do [(offset m) + 2 * (size*row + col) ] (bo WORD) wartosc
;
; a(row)0 * b0(col) +
; a(row)1 * b1(col) +
; . +
; . +
; . +
; a(row)n * bn(col)
;
; a(row)(i) = [offset m1 + row*size + i]
; b(i)(col) = [offset m2 + i*size + col]
; 
mulcell proc row:WORD, col:WORD, mcsize:WORD
		push ax
		push bx
		push cx
		push dx
		push di
		push si
		
		xor di, di
		mov tmpwrd, di			; tymczasowa suma
		mov tmpwrd2, di			; starszy bajt
nextmult:	
		xor  bx, bx			; offset M1
		mov  bx, offset m1		;
		xor  ax, ax			; w ax offset pierwszej liczby
		mov  ax, row			; w danym rzedzie
		xor  cx, cx			; (czyli row * dlugosc serii liczb)
		mov  cx, mcsize
		mul  cl
		add  bx, ax			; w bx M1 + pocztek rzedu +
		add  bx, di			;         + ktory skladnik

		xor  ax, ax
		mov  al, [bx]		; 1 czynnik danego skladnika
		push ax			; na stos

		mov  bx, bx			; offset M2 +
		mov  bx, offset m2		
		xor  ax, ax
		mov  ax, di			; ktory skladnik
		xor  cx, cx			;  (inaczej numer rzedu)
		mov  cl, m2c			; ilosc kolumn w M2
		mul  cl				;  (czyli dlugosc rzedu)
		add  bx, ax			; + offset rzedu w ktorym jest czynnik do danego skladnika +
		add  bx, col			; + numer kolumny

		xor  ax, ax
		mov  al, [bx]		; 2 czynnik danego skladnika...

		xor  bx, bx
		mov  bl, al		; ... do bl
		pop  ax			; 1 czynnik do al
		mul  bl			; mnozenie

		add  tmpwrd, ax		; i do sumy
		jnc  malasuma
		inc  tmpwrd2

malasuma:	inc  di
		cmp  di, mcsize
		jle  nextmult		; i nastepny skladnik

		mov  bx, offset m	; offset M +
		mov  si, col		; + kolumna
		xor  ax, ax
		mov  ax, row		; + rzad *
		xor  cx, cx
		mov  cl, m2c		; * jego dlugosc
		mul  cl
		add  ax, si
		mov  si, ax

		add  si, ax		; WORD
		add  si, ax		; x
		add  si, ax		; 2

		mov  ax, tmpwrd
		mov  [bx+si], ax
		inc  si
		inc  si
		mov  ax, tmpwrd2
		mov  [bx+si], ax
		
		pop  si
		pop  di
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret
mulcell endp

; pobiera z pliku wejsciowego LF
getlf proc
		push ax
		push bx
		push cx
		push dx
		xor  ax, ax
		mov  tmpnum, al			; zeruj tmpnum
		mov  ah, 3fh			; czytaj
		mov  bx, srcfh			; z pliku wej.
		mov  cx, 1			; jeden bajt
		mov  dx, offset tmpnbuf		; do bufora
		int  21h
		mov  bx, offset tmpnbuf
		jc   bladlf			; jesli sie nie udalo - zglos
		cmp  byte ptr ds:[bx], 10	; jesli nie byl to LF
		jne  bladlf			;  - zglos
		mov  ax, sfpos
		inc  ax				; zwieksz pozycje w pliku
		mov  sfpos, ax
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret
bladlf:		mov  dx, offset errmatlf	; wypisanie bledu
		call helpmsg
getlf endp


; wczytuje rzad liczb o dlugosci podanej w parametrze
ldrow proc lrsize:WORD, row:WORD
		push ax
		push di
		push bx
		push cx
		mov  bx, row			; tu wrzucaj liczby z rzedu
		xor  di, di			; wyzeruj offset
		mov  cx, lrsize			; laduj size-1 liczb
						; oddzielonych spacjami
ldrnextnum:	dec  cx
		cmp  cx, 0
		je   ldrendl
		call readnum, 0020h		; pobierz liczbe
		mov  al, byte ptr tmpnum	; przenies ja
		mov  byte ptr ds:[bx+di], al	; do tablicy
		inc  di				; zwieksz offset
		jmp  ldrnextnum			; pobierz nastepna...
		
ldrendl:	call readnum, 0013		; pobierz liczbe zakonczona CR
		mov  al, byte ptr tmpnum
		mov  byte ptr ds:[bx+di], al
		call getlf			; przeskocz LF na koncu rzedu
		pop  cx
		pop  bx
		pop  di
		pop  ax
		ret
ldrow endp

; wczytuje macierz 1
ldmatrix1 proc
		push ax
		push bx
		push cx
		push dx
		mov  bx, offset m1		; tu wrzucaj liczby z macierzy
		xor  cx, cx
		xor  ax, ax
		mov  cl, m1r			; laduj 'ilosc rzedow' rzedow
		mov  al, m1c			; o wielkosci 'ilosc kolumn'
ldmnextrow1:	call ldrow, ax, bx		; pobierz rzad
		add  bx, ax			; zwieksz offset
		loop ldmnextrow1		; pobierz nastepny...
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret
ldmatrix1 endp

; wczytuje macierz 2
ldmatrix2 proc
		push ax
		push bx
		push cx
		push dx
		mov  bx, offset m2		; tu wrzucaj liczby z macierzy
		xor  ax, ax
		xor  cx, cx
		mov  cl, m2r			; laduj 'ilosc rzedow' rzedow
		mov  al, m2c			; o wielkosci 'ilosc kolumn'
ldmnextrow2:	call ldrow, ax, bx		; pobierz rzad
		add  bx, ax			; zwieksz offset
		loop ldmnextrow2		; pobierz nastepny...
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret
ldmatrix2 endp

; wczytuje liczbe z pliku wejsciowego do zmienniej tmpnum
; jako parametr - znak, ktorym moze sie konczyc dana liczba (CR lub ' ')
readnum proc ech:WORD
		push ax
		push bx
		push cx
		push dx
		push di				; zapis rejestrow
		xor  ax, ax
		mov  tmpnum, al			; zeruj tmpnum
		mov  ah, 3fh			; czytaj
		mov  bx, srcfh			; z pliku wej.
		mov  cx, 4			; cztery bajty
		mov  dx, offset tmpnbuf		; do bufora
		int  21h
		jc   bladczytania		; jesli sie nie udalo wypisz blad
		mov  bx, offset tmpnbuf		; potrzebne do indeksowania
		mov  cx, ax			; licznik petli
		xor  di, di			; offset znaku przy szukaniu spacji
rdnextchar:	cmp  byte ptr ds:[bx+di], '0'	; jesli znakiem
		jl   endofdigits		;   nie byla
		cmp  byte ptr ds:[bx+di], '9'	;   cyfra to znaczy
		jg   endofdigits		;   ze mamy cala liczbe
		inc  di				; zwiekszenie offsetu
		loop rdnextchar			; i ponowne wykonanie petli
endofdigits:	cmp  di, 0			; jesli nie bylo zadnych cyfr
		je   rdnerror			; lub jesli liczba
		push ax
		xor  ax, ax
		mov  ax, ech
		cmp  byte ptr ds:[bx+di], al	; nie byla zakonczona
		pop  ax
		jne  rdnerror			; odpowiednim znakiem
		jmp  therewasdigit
rdnerror:	mov  dx, offset errdata		; to wypisz blad
		call helpmsg
	; w tym momencie w di jest offset ostatniej cyfry + 1
	; wiec jest to stosowny moment do ustawienia pozycji pliku
	; zeby mozna bylo odczytac bez problemu nastepna liczbe
therewasdigit:	inc  di
		add  sfpos, di
		call lseek, sfpos
		dec  di				; usuwamy ^^^ ta jedynke
		;dec  di	to co dodalem - nie, zeby petla dzialala ok
		mov  cx, di			; licznik petli konwersji
		mov  dl, 1			; mnoznik dla jednosci
atoi:		mov  al, byte ptr ds:[bx+di-1]	; pobieramy cyfre jako znak
		sub  al, '0'			; zamieniamy ja na bajt
		mul  dl;*al			; mnozymy stosownie do pozycji
		add  tmpnum, al			; i dodajemy do calej liczby
		push ax
		mov  al, dl
		mov  dl, 10
		mul  dl				; zwiekszamy mnoznik o rzad
		mov  dl, al
		pop  ax
		dec  di				; przesuwamy pozycje
		loop atoi			; konwertujemy dalej
		xor  ax, ax
		mov  al, 100			; sprawdzamy czy
		cmp  tmpnum, al			; odczytana liczba
		jg   rnetoobig			; nie jest wieksza niz 100
		pop  di
		pop  dx
		pop  cx
		pop  bx
		pop  ax				; przywracamy rejestry
		ret				; i wracamy
bladczytania:	mov  dx, offset erread		; wypisywanie bledu
		call helpmsg
rnetoobig:	mov  dx, offset errtoobig	; liczba za duza
		call helpmsg
readnum endp


; ustawia pozycje w pliku wejsciowym na ta podana w parametrze
lseek proc whereto:WORD
		push ax
		push bx
		push cx
		push dx
		xor  cx, cx
		mov  dx, whereto	; offset
		mov  ah, 42h		; lseek()
		mov  al, 0		; origin = BOF
		mov  bx, srcfh		; plik wejsciowy
		int  21h
		jc   lseekerr
		pop  dx
		pop  cx
		pop  bx
		pop  ax
		ret
lseekerr:	mov  dx, offset errlseek
		call helpmsg
lseek endp

; wypisuje string wskazywany przez dx
write proc
		push ax
		mov  ah, 9
		int  21h
		pop  ax
		ret
write endp

; wypisuje string wskazywany przez bx o dlugosci w cx
mywrite proc
		push ax
		push si
		push dx
		mov  ah, 2
		xor  si, si
mwl:		mov  dl, ds:[bx+si]
		int  21h
		inc  si
		loop mwl
		pop  dx
		pop  si
		pop  ax
		ret
mywrite endp

; pomoc - ustaw dx na komunikat bledu
helpmsg proc
		push dx
		mov  dx, offset endl
		call write
		pop  dx
		call write
		mov  dx, offset endl
		call write
		mov  ah, 4ch
		mov  al, 1
		int  21h
helpmsg endp

; informacja - ustaw dx na komunikat
debugmsg proc
		call write
		mov  dx, offset endl
		call write
		ret
debugmsg endp

strcpy proc dstoff:WORD, srcoff:WORD
		push di
		push bx
		mov  bx, srcoff
		xor  di, di			; zeruj licznik
snch:		mov  bx, srcoff
		mov  al, byte ptr es:[bx+di]	; pobierz znak
		cmp  al, ' '			; jesli jest to spacja
		jz   scend			; 	to koncz
		cmp  al, 13			; jesli koniec opcji (CR)
		jz   scend			;	to tez koncz
		mov  bx, dstoff
		mov  byte ptr ds:[bx+di], al	; w przeciwnym wypadku skopiuj znak
		inc  di				; zwieksz licznik
		jmp  snch			; i jeszcze raz
scend:		cmp  di, 0			; jesli string byl pusty
		jne  wasstr
		call helpmsg			; 	to zglos blad
wasstr:		mov  ax, di			; zwracamy dlugosc licznika w ax
		pop  bx
		pop  di
		inc  ax				; przeskakujemy spacje
		ret
strcpy endp

open proc fnam:WORD
		push ax
		push cx
		push dx
		xor  ax, ax		; O_RONLY
		mov  ah, 3dh		; open()
		mov  al, 0
		mov  dx, fnam
		int  21h
		jnc  openok		; jesli sie nie udalo to
		lea  dx, erropen	; zglos
		call helpmsg		; blad
openok:		mov  srcfh, ax
		pop  dx
		pop  cx
		pop  ax
		ret
open endp

creat proc fnam:WORD
		push dx
		xor  ax, ax
		mov  ah, 3ch		; creat()
		mov  dx, fnam
		int  21h
		jnc  creatok		; jesli sie nie udalo
		lea  dx, errcreat	; to zglos
		call helpmsg		; blad
creatok:	mov  dstfh, ax
		pop  dx
		ret
creat endp

close proc fh:WORD
		push dx
		xor  ax, ax
		mov  ah, 3eh		; close()
		mov  bx, fh
		int  21h
		jnc  closeok		; jesli sie nie udalo
		lea  dx, errclose	; to zglos
		call helpmsg		; blad
closeok:	pop  dx
		ret
close endp

end start
